// Generated by rstantools.  Do not edit by hand.

/*
    hwep is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    hwep is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with hwep.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_gl_null_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 30> locations_array__ =
  {" (found before start of program)",
  " (in 'gl_null', line 9, column 2 to column 19)",
  " (in 'gl_null', line 13, column 2 to column 17)",
  " (in 'gl_null', line 15, column 4 to column 36)",
  " (in 'gl_null', line 16, column 4 to column 32)",
  " (in 'gl_null', line 17, column 4 to column 15)",
  " (in 'gl_null', line 19, column 6 to column 34)",
  " (in 'gl_null', line 18, column 23 to line 20, column 5)",
  " (in 'gl_null', line 18, column 4 to line 20, column 5)",
  " (in 'gl_null', line 14, column 21 to line 21, column 3)",
  " (in 'gl_null', line 14, column 2 to line 21, column 3)",
  " (in 'gl_null', line 24, column 2 to column 38)",
  " (in 'gl_null', line 26, column 11 to column 14)",
  " (in 'gl_null', line 26, column 4 to column 19)",
  " (in 'gl_null', line 28, column 6 to column 35)",
  " (in 'gl_null', line 27, column 23 to line 29, column 5)",
  " (in 'gl_null', line 27, column 4 to line 29, column 5)",
  " (in 'gl_null', line 30, column 4 to column 30)",
  " (in 'gl_null', line 25, column 17 to line 31, column 3)",
  " (in 'gl_null', line 25, column 2 to line 31, column 3)",
  " (in 'gl_null', line 2, column 2 to column 17)",
  " (in 'gl_null', line 3, column 2 to column 17)",
  " (in 'gl_null', line 4, column 2 to column 21)",
  " (in 'gl_null', line 5, column 9 to column 10)",
  " (in 'gl_null', line 5, column 12 to column 15)",
  " (in 'gl_null', line 5, column 2 to column 20)",
  " (in 'gl_null', line 6, column 9 to column 14)",
  " (in 'gl_null', line 6, column 2 to column 22)",
  " (in 'gl_null', line 9, column 10 to column 15)",
  " (in 'gl_null', line 13, column 10 to column 13)"};
#include <stan_meta_header.hpp>
class model_gl_null final : public model_base_crtp<model_gl_null> {
private:
  int N;
  int K;
  int khalf;
  Eigen::Matrix<double,-1,-1> gl_data__;
  Eigen::Matrix<double,-1,1> alpha_data__;
  int q_1dim__;
  Eigen::Map<Eigen::Matrix<double,-1,-1>> gl{nullptr, 0, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> alpha{nullptr, 0};
public:
  ~model_gl_null() {}
  model_gl_null(stan::io::var_context& context__, unsigned int
                random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_gl_null_namespace::model_gl_null";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 20;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 20;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 20;
      stan::math::check_greater_or_equal(function__, "N", N, 0);
      current_statement__ = 21;
      context__.validate_dims("data initialization", "K", "int",
        std::vector<size_t>{});
      K = std::numeric_limits<int>::min();
      current_statement__ = 21;
      K = context__.vals_i("K")[(1 - 1)];
      current_statement__ = 21;
      stan::math::check_greater_or_equal(function__, "K", K, 2);
      current_statement__ = 22;
      context__.validate_dims("data initialization", "khalf", "int",
        std::vector<size_t>{});
      khalf = std::numeric_limits<int>::min();
      current_statement__ = 22;
      khalf = context__.vals_i("khalf")[(1 - 1)];
      current_statement__ = 22;
      stan::math::check_greater_or_equal(function__, "khalf", khalf, 2);
      current_statement__ = 23;
      stan::math::validate_non_negative_index("gl", "N", N);
      current_statement__ = 24;
      stan::math::validate_non_negative_index("gl", "K + 1", (K + 1));
      current_statement__ = 25;
      context__.validate_dims("data initialization", "gl", "double",
        std::vector<size_t>{static_cast<size_t>(N),
          static_cast<size_t>((K + 1))});
      gl_data__ = Eigen::Matrix<double,-1,-1>::Constant(N, (K + 1),
                    std::numeric_limits<double>::quiet_NaN());
      new (&gl) Eigen::Map<Eigen::Matrix<double,-1,-1>>(gl_data__.data(), N,
        (K + 1));
      {
        std::vector<local_scalar_t__> gl_flat__;
        current_statement__ = 25;
        gl_flat__ = context__.vals_r("gl");
        current_statement__ = 25;
        pos__ = 1;
        current_statement__ = 25;
        for (int sym1__ = 1; sym1__ <= (K + 1); ++sym1__) {
          current_statement__ = 25;
          for (int sym2__ = 1; sym2__ <= N; ++sym2__) {
            current_statement__ = 25;
            stan::model::assign(gl, gl_flat__[(pos__ - 1)],
              "assigning variable gl", stan::model::index_uni(sym2__),
              stan::model::index_uni(sym1__));
            current_statement__ = 25;
            pos__ = (pos__ + 1);
          }
        }
      }
      current_statement__ = 26;
      stan::math::validate_non_negative_index("alpha", "khalf", khalf);
      current_statement__ = 27;
      context__.validate_dims("data initialization", "alpha", "double",
        std::vector<size_t>{static_cast<size_t>(khalf)});
      alpha_data__ = Eigen::Matrix<double,-1,1>::Constant(khalf,
                       std::numeric_limits<double>::quiet_NaN());
      new (&alpha)
        Eigen::Map<Eigen::Matrix<double,-1,1>>(alpha_data__.data(), khalf);
      {
        std::vector<local_scalar_t__> alpha_flat__;
        current_statement__ = 27;
        alpha_flat__ = context__.vals_r("alpha");
        current_statement__ = 27;
        pos__ = 1;
        current_statement__ = 27;
        for (int sym1__ = 1; sym1__ <= khalf; ++sym1__) {
          current_statement__ = 27;
          stan::model::assign(alpha, alpha_flat__[(pos__ - 1)],
            "assigning variable alpha", stan::model::index_uni(sym1__));
          current_statement__ = 27;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 28;
      stan::math::validate_positive_index("p", "khalf", khalf);
      current_statement__ = 29;
      q_1dim__ = std::numeric_limits<int>::min();
      current_statement__ = 29;
      q_1dim__ = (K + 1);
      current_statement__ = 29;
      stan::math::validate_non_negative_index("q", "K + 1", q_1dim__);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = (khalf - 1);
  }
  inline std::string model_name() const final {
    return "model_gl_null";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_gl_null_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<local_scalar_t__,-1,1> p =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(khalf, DUMMY_VAR__);
      current_statement__ = 1;
      p = in__.template read_constrain_simplex<
            Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(lp__, khalf);
      Eigen::Matrix<local_scalar_t__,-1,1> q =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(q_1dim__, DUMMY_VAR__);
      current_statement__ = 10;
      for (int k = 1; k <= (K + 1); ++k) {
        int iup = std::numeric_limits<int>::min();
        current_statement__ = 3;
        iup = stan::math::min((k - 1), (khalf - 1));
        int ilo = std::numeric_limits<int>::min();
        current_statement__ = 4;
        ilo = stan::math::max(0, (k - khalf));
        current_statement__ = 5;
        stan::model::assign(q, 0.0, "assigning variable q",
          stan::model::index_uni(k));
        current_statement__ = 8;
        for (int i = ilo; i <= iup; ++i) {
          current_statement__ = 6;
          stan::model::assign(q,
            (stan::model::rvalue(q, "q", stan::model::index_uni(k)) +
            (stan::model::rvalue(p, "p", stan::model::index_uni((i + 1))) *
            stan::model::rvalue(p, "p", stan::model::index_uni((k - i))))),
            "assigning variable q", stan::model::index_uni(k));
        }
      }
      current_statement__ = 2;
      stan::math::check_simplex(function__, "q", q);
      {
        current_statement__ = 11;
        lp_accum__.add(stan::math::dirichlet_lpdf<false>(p, alpha));
        current_statement__ = 19;
        for (int i = 1; i <= N; ++i) {
          current_statement__ = 12;
          stan::math::validate_non_negative_index("lq", "K + 1", (K + 1));
          Eigen::Matrix<local_scalar_t__,-1,1> lq =
            Eigen::Matrix<local_scalar_t__,-1,1>::Constant((K + 1),
              DUMMY_VAR__);
          current_statement__ = 16;
          for (int j = 1; j <= (K + 1); ++j) {
            current_statement__ = 14;
            stan::model::assign(lq,
              (stan::model::rvalue(gl, "gl", stan::model::index_uni(i),
                 stan::model::index_uni(j)) +
              stan::math::log(
                stan::model::rvalue(q, "q", stan::model::index_uni(j)))),
              "assigning variable lq", stan::model::index_uni(j));
          }
          current_statement__ = 17;
          lp_accum__.add(stan::math::log_sum_exp(lq));
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_gl_null_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<double,-1,1> p =
        Eigen::Matrix<double,-1,1>::Constant(khalf,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 1;
      p = in__.template read_constrain_simplex<
            Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(lp__, khalf);
      Eigen::Matrix<double,-1,1> q =
        Eigen::Matrix<double,-1,1>::Constant(q_1dim__,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(p);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 10;
      for (int k = 1; k <= (K + 1); ++k) {
        int iup = std::numeric_limits<int>::min();
        current_statement__ = 3;
        iup = stan::math::min((k - 1), (khalf - 1));
        int ilo = std::numeric_limits<int>::min();
        current_statement__ = 4;
        ilo = stan::math::max(0, (k - khalf));
        current_statement__ = 5;
        stan::model::assign(q, 0.0, "assigning variable q",
          stan::model::index_uni(k));
        current_statement__ = 8;
        for (int i = ilo; i <= iup; ++i) {
          current_statement__ = 6;
          stan::model::assign(q,
            (stan::model::rvalue(q, "q", stan::model::index_uni(k)) +
            (stan::model::rvalue(p, "p", stan::model::index_uni((i + 1))) *
            stan::model::rvalue(p, "p", stan::model::index_uni((k - i))))),
            "assigning variable q", stan::model::index_uni(k));
        }
      }
      current_statement__ = 2;
      stan::math::check_simplex(function__, "q", q);
      if (emit_transformed_parameters__) {
        out__.write(q);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> p =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(khalf, DUMMY_VAR__);
      current_statement__ = 1;
      stan::model::assign(p,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(khalf),
        "assigning variable p");
      out__.write_free_simplex(p);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "p", "double",
        std::vector<size_t>{static_cast<size_t>(khalf)});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> p =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(khalf, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> p_flat__;
        current_statement__ = 1;
        p_flat__ = context__.vals_r("p");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= khalf; ++sym1__) {
          current_statement__ = 1;
          stan::model::assign(p, p_flat__[(pos__ - 1)],
            "assigning variable p", stan::model::index_uni(sym1__));
          current_statement__ = 1;
          pos__ = (pos__ + 1);
        }
      }
      out__.write_free_simplex(p);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"p"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"q"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{static_cast<
                                                                    size_t>(
                                                                    khalf)}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(q_1dim__)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= khalf; ++sym1__) {
      param_names__.emplace_back(std::string() + "p" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= q_1dim__; ++sym1__) {
        param_names__.emplace_back(std::string() + "q" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= (khalf - 1); ++sym1__) {
      param_names__.emplace_back(std::string() + "p" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= (q_1dim__ - 1); ++sym1__) {
        param_names__.emplace_back(std::string() + "q" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"p\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(khalf) + "},\"block\":\"parameters\"},{\"name\":\"q\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(q_1dim__) + "},\"block\":\"transformed_parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"p\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string((khalf -1)) + "},\"block\":\"parameters\"},{\"name\":\"q\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string((q_1dim__ -1)) + "},\"block\":\"transformed_parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = khalf;
    const size_t num_transformed = emit_transformed_parameters * (q_1dim__);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = khalf;
    const size_t num_transformed = emit_transformed_parameters * (q_1dim__);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_gl_null_namespace::model_gl_null;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_gl_null_namespace::profiles__;
}
#endif
#endif
